

#ifndef  __TIMER_H__
#define  __TIMER_H__


#include <cstdint>
#include "interrupt.H"


extern "C++" {
	namespace avelino {
		using namespace std;

		class TimerListener {
			public:
				virtual void timerExpired() = 0;
		};

		uint64_t operator "" _msForTimer(unsigned long long v);

		uint64_t operator "" _usForTimer(unsigned long long v);

		class Timer {
			public:
				static uint64_t interval;
				static TimerListener *listener;
				static void init(TimerListener &listener, uint64_t interval = 1000_msForTimer);
                static void interrupt()  __attribute__ ((interrupt, section(SYSTICK_INT_SECTION)));
		};
	}
}


#endif  // __TIMER_H__
