

#include <stdint.h>
#include "interrupt.H"
#include "Timer.H"


using namespace std;
using namespace avelino;


class MyTimerListener : public TimerListener {
    public:
        MyTimerListener();
        virtual void timerExpired();
};


#define  RCC_APB2PCENR  *((uint32_t *) 0x40021018)
#define  GPIOD_CFGLR    *((uint32_t *) 0x40011400)
#define  GPIOD_OUTDR    *((uint32_t *) 0x4001140C)


MyTimerListener::MyTimerListener() {
	// enable clock on GPIOD
	RCC_APB2PCENR |= (((uint32_t) 1) << 5);
	// led on PD6
	GPIOD_CFGLR = (GPIOD_CFGLR & 0xF0FFFFFF) | 0x02000000;   // PD6 = output push-pull
}


void MyTimerListener::timerExpired() {
	GPIOD_OUTDR ^= (((uint32_t) 1) << 6);
}


int main() {
    interruptInit();
    MyTimerListener myTimerListener;
    Timer::init(myTimerListener, 250_msForTimer);
	while (true)
		asm volatile ("wfi");
}
